﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;

namespace DotNETWork.Globals
{
    public static class Extension
    {
        public static byte[] SerializeToByteArray(this object _object)
        {
            byte[] bytes;
            using (var _MemoryStream = new MemoryStream())
            {
                IFormatter _BinaryFormatter = new BinaryFormatter();
                _BinaryFormatter.Serialize(_MemoryStream, _object);
                bytes = _MemoryStream.ToArray();
            }
            return bytes;
        }

        public static dynamic DeserializeToDynamicType(this byte[] _byteArray)
        {
            using (var _MemoryStream = new MemoryStream(_byteArray))
            {
                IFormatter _BinaryFormatter = new BinaryFormatter();
                var ReturnValue = _BinaryFormatter.Deserialize(_MemoryStream);
                return ReturnValue;
            }
        }

        public static List<byte[]> StackByteArray(this byte[] inputArray, int stackSize)
        {
            List<byte[]> _packets = new List<byte[]>();
            byte[] _byteCollection = null;

            int _amountPacket = 0;
            if ((double)inputArray.Length / (double)stackSize >= 1)
                _amountPacket = inputArray.Length / stackSize;

            for (int i = 0; i <= _amountPacket; i++)
            {
                int _amount = (i * stackSize) + stackSize;

                if (inputArray.Length - i * stackSize < stackSize)
                    _byteCollection = new byte[inputArray.Length - i * stackSize];
                else _byteCollection = new byte[stackSize];

                Array.Copy(inputArray, i * stackSize, _byteCollection, 0, _byteCollection.Length);
                _packets.Add(_byteCollection);
            }
            return _packets;
        }
    }
}
